#include <stdio.h>

typedef unsigned int uint;

const char *szInput = "MUSEUM.DAT";
const char *szOutput = "MUSEUM.SOL";

uint *arHalls;
uint N;

uint factorial(uint n)
{
	uint result = 1;
	for (uint i = 0; i < n; i++)
		result *= n - i;
	return result;
}

int main()
{
	uint P;
	FILE *fIn = fopen(szInput, "rt");
	//Reading file...
	fscanf(fIn, "%u %u\n", &N, &P);

	arHalls = new uint[N];
	for (uint i = 0; i < N; i++) arHalls[i] = 1;

	uint A, B;
	for (uint i = 0; i < N; i++)
	{
		fscanf(fIn, "%u %u\n", &A, &B);
		arHalls[A - 1]++;
		arHalls[B - 1]++;
	}
	fclose(fIn);

	uint uResult = factorial(N) / (factorial(N - arHalls[0]) * factorial(N - arHalls[0]));

	FILE *fOut = fopen(szOutput, "wt");
	//Writing file...
	fprintf(fOut, "%u\n", uResult % P);
	fclose(fOut);
	return 0;
}