#include <stdio.h>

typedef unsigned int uint;

const char *szInput = "MUTATION.DAT";
const char *szOutput = "MUTATION.SOL";

uint A, B, N, M;
char gen1[40000], gen2[40000];

bool streq(char *str1, char *str2, uint iLen)
{
	for (uint i = 0; i < iLen; i++)
		if (str1[i] != str2[i]) return false;
	return true;
}

int main()
{
	FILE *fIn = fopen(szInput, "rt");
	//Reading file...
	fscanf(fIn, "%u %u %u %u\n", &A, &B, &N, &M);
	fscanf(fIn, "%s\n", gen1);
	fscanf(fIn, "%s\n", gen2);

	char *genFull1 = new char[N], *genFull2 = new char[N];
	for (uint i = 0; i < N; i += A)
	{
		for (uint j = 0; j < A; j++) genFull1[i + j] = gen1[j];
	}

	for (uint i = 0; i < N; i += B)
	{
		for (uint j = 0; j < B; j++) genFull2[i + j] = gen2[j];
	}
	
	uint iCount;
	for (uint i = 0; i < M; i++)
	{
		fscanf(fIn, "%u\n", &iCount);
		for (uint j = 0; ((iCount > 0)&&(j < N)); j++)
		{
			if (genFull1[j] != genFull2[j])
			{
				genFull1[j] = genFull2[j];
				iCount--;
			}
		}

		for (; iCount > 0; iCount--)
			if (genFull1[iCount] == '0') genFull1[iCount] = '1';
			else genFull1[iCount] = '0';

		if (streq(genFull1, genFull2, N))
		{
			if (i != 0) iCount = i + 1;
			else iCount = 0;
			break;
		}
	}

	fclose(fIn);

	FILE *fOut = fopen(szOutput, "wt");
	//Writing file...
	fprintf(fOut, "%u\n", iCount);
	fclose(fOut);
	return 0;
}