#include <cstdio>

using namespace std;

FILE *fi = fopen("POLYNOM.DAT", "rt"),
	*fo = fopen("POLYNOM.SOL", "wt");

int powermod(int x, int y, int m)
{
	int a = x, b = 1;
	while (y)
	{
		if (y % 2)
			b = (b * a) % m;
		a = (a * a) % m;
		y /= 2;
	}
	return b;
}

int main(int argc, char *argv[])
{
	int n;
	fscanf(fi, "%d", &n);
	int m = (n*n*(n*n + 1) / 2) % 9973;
	fprintf(fo, "%d\n", powermod(m, n, 9973));
	fclose(fi);
	fclose(fo);
	return 0;
}