#include <fstream>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <string>
#include <queue>
#include <algorithm>
#include <cmath>
#define x first
#define y second
using namespace std;
#define LL long long
int dfs(int cur,vector<vector<int> >&a,vector<int> &used,vector<bool> &us,int cntus,int &modul)
{
	int res=0;
	if(cntus==used.size()-1) return 1;
	bool cycle=true;
	bool step=false;
	while(cycle)
	{
		for(int i=0;i<a[cur].size() && !(used[cur]==cur || used[used[cur]]==cur);i++)
			if(!used[a[cur][i]])
			{
				us[cur]=true;
				used[a[cur][i]]=cur;
				cycle=false;
				res+=dfs(a[cur][i],a,used,us,cntus+1,modul);
				used[a[cur][i]]=0;
				us[cur]=false;
			}
		if(cycle)
			for(int i=1;i<used.size();i++) 
				if(!used[i])
				{
					cur=i;
					break;
				}
		if(us[cur]) return 0;
	}
	return res%modul;
}
int main()
{
	ifstream cin("museum.dat");
	ofstream cout("museum.sol");
	int n,modul;
	cin>>n>>modul;
	n++;
	vector<vector<int> >a(n);
	int from,to;
	for(int i=1;i<n;i++)
	{
		cin>>from>>to;
		a[from].push_back(to);
		a[to].push_back(from);
		a[i].push_back(i);
	}
	for(int i=1;i<n;i++) sort(a[i].begin(),a[i].end());
	int cnt=0;
	vector<int> used(n);
	vector<bool> us(n);
	int cur=1;
	for(int i=0;i<a[cur].size();i++)
	{
		used[a[cur][i]]=1;
		us[cur]=true;
		cnt+=dfs(a[cur][i],a,used,us,1,modul);
		used[a[cur][i]]=0;
		us[cur]=false;
	}
	cout<<cnt%modul<<endl;
	cin.close();
	cout.close();
	return 0;
}