program POLYNOM;

{$APPTYPE CONSOLE}

uses Windows;

type
  BN = array[1..2000] of byte;

var
  F: TextFile;
  Q, VQ: BN;

procedure Print(w: integer);
var
  i: integer;
begin
  for i := w downto 1 do
    Write(F, Q[i]);

  Writeln(F);
end;

procedure BNM(var Q: BN; st: integer; var w: integer);
var
  y, i, j: integer;
  V: BN;
  k, u: byte;
begin
  for y := 1 to st - 1 do
  begin
    for i := 1 to w do
    begin
      V[i] := Q[i];
      Q[i] := 0;
    end;

    for i := 1 to w do
    begin
      u := 0;
      for j := 1 to w do
      begin
        k := Q[i + j - 1] + V[i] * VQ[j] + u;
        Q[i + j - 1] := k mod 10;
        u := k div 10;
      end
    end;
    w := w + w;

    for i := w downto 1 do
      if Q[i] = 0 then
        dec(w)
      else
        break;
  end;
end;

procedure GetResult(var N: byte);
var
  i, z: byte;
  w: integer;
  N2: integer;
  P, P2: int64;
  P3: String;
  Res: int64;
begin
  Res := 0;

  N2 := N * N;
  P := Trunc((1 + N2) * (N2 / 2));

  if N <= 4 then
    Res := Trunc(exp(N * ln(P)))
  else begin
    P2 := P;
    w := 0;
    while P2 <> 0 do
    begin
      inc(w);
      P2 := P2 div 10
    end;

    Str(P, P3);

    z := 0;
    for i := w downto 1 do
    begin
      inc(z);
      Q[z] := ord(P3[i]) - 48
    end;

    for i := 1 to w do
      VQ[i] := Q[i];
    BNM(Q, N, w)
  end;

  AssignFile(F, 'POLYNOM.SOL');
  Rewrite(F);

  if N <= 4 then
    Writeln(F, Res)
  else
    Print(w);

  CloseFile(F);
end;

var
  N: byte;

begin
  AssignFile(F, 'POLYNOM.DAT');
  Reset(F);

  Readln(F, N);

  CloseFile(F);

  GetResult(N);
end.
