#ifndef _DEBUG
	#define __OPTIMIE__ 3
#endif
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <list>
typedef long long ll;
typedef unsigned short us;
typedef unsigned int uint;
using namespace std;
struct lint{
#define eSize 4
#define eMax 9999
#define eUp (eMax+1)
	list<us> data;
	lint():data(){
		data.push_front(0);
	}
	lint(uint x):data(){
		while (x){
			data.push_back(x%eUp);
			x/=eUp;
		}
		if (data.empty()) data.push_front(0);
	}
	lint &operator =(const lint &x){ data=x.data; return *this;}
	lint &operator +=(const lint &x){
		uint a=0;
		list<us>::reverse_iterator i=data.rbegin();
		list<us>::const_reverse_iterator j=x.data.rbegin();
		for (; j!=x.data.rend(); ++i,++j){			
			a+=*j;
			if (i!=data.rend()){
				a+=*i;
				*i=a%eUp;				
			} else data.push_front(a%eUp);
			a/=eUp;
		}
		while (a){
			if (i!=data.rend()) {
				*i=a;
				++i;
			}else data.push_front(a);
			a/=eUp;
		}
		return *this;
	}
	lint &operator *=(uint x){
		uint a=0;
		for (list<us>::reverse_iterator i=data.rbegin(); i!=data.rend(); ++i){
			a+=(*i)*x;
			*i=a%eUp;
			a/=eUp;
		}
		while (a) {
			data.push_front(a%eUp);
			a/=eUp;
		}
		return *this;
	}
	uint operator %(uint x) const {
		uint r=0;
		for (list<us>::const_iterator i=data.begin(); i!=data.end(); ++i){
			r*=eUp;
			r+=*i;
			r%=x;
		}
		return r;
	}
};
int main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
#else
	freopen("polynom.dat","r",stdin);
	freopen("polynom.sol","w",stdout);
#endif
	uint N,N2,t; cin>>N; N2=N*N;
	t=(N2*(N2+1))/2;
	lint x(1);
	for (int i=0; i<N; i++) x*=t;
	uint d=x%9973;
	cout<<d<<'\n'; 
	return 0;
}