#include <fstream>
#include <queue>

using namespace std;
ifstream fin("Museum.dat");
ofstream fout("Museum.sol");
const long long MNAX = 50000;
const long long NFIRST = 1500;
long long sp[MNAX+2][NFIRST+2];
long long n,p,ans=0;
long long stree[MNAX+2];
long long krug[MNAX+2];
long long used[MNAX+2];


int main(){
	long long i,j;
	memset(stree,0,sizeof(long long)*(MNAX+2));
	memset(krug,0,sizeof(long long)*(MNAX+2));
	memset(used,0,sizeof(long long)*(MNAX+2));
	fin>>n>>p;

	if (n==3){
		fout<<6%p<<'\n';
		return 0;
	}

	stree[1]=1;stree[2]=2%p;
	for (i=3;i<=n;++i){stree[i] = (stree[i-1]+stree[i-2])%p;}
	for (i=3;i<=n;++i){krug[i] = (3+i*stree[i-2])%p;}


	for (i=0;i<=MNAX+1;++i){
		sp[i][0]=0;
	}

	queue <long long> q;
	queue <long long> q2;
	while (q.empty()==false){q.pop();}
	while (q2.empty()==false){q2.pop();}


	for (i=1;i<=n;++i){
		long long x,y;
		fin>>x>>y;
		++sp[x][0];
		sp[x][sp[x][0]] = y;
		if (x!=y){
			++sp[y][0];
			sp[y][sp[y][0]] = x;
		}
	}
	long long kk=0;
	q.push(1);q2.push(0);used[1]=1;
	while (q.empty()==false){
		long long k = q.front();
		q.pop();
		long long k2 = q2.front();
		q2.pop();
		for (i=1;i<=sp[k][0];++i){
			if (used[sp[k][i]]==0){
				q.push(sp[k][i]);
				q2.push(k);
				used[sp[k][i]] = used[k]+1;
			}
			else if (sp[k][i]!=k2){
				//ans = krug[used[k2]+1-used[i]];
				kk = sp[k][i];break;
			}
		}
		if (kk>0) break;
	}

	while (q.empty()==false){q.pop();}
	while (q2.empty()==false){q2.pop();}
	memset(used,0,sizeof(long long)*(MNAX+2));
	long long kans=0;
	q.push(kk);q2.push(0);used[kk]=1;
	while (q.empty()==false){
		long long k = q.front();
		q.pop();
		long long k2 = q2.front();
		q2.pop();
		for (i=1;i<=sp[k][0];++i){
			if (used[sp[k][i]]==0){
				q.push(sp[k][i]);
				q2.push(k);
				used[sp[k][i]] = used[k]+1;
			}
			else if (sp[k][i]!=k2 && ans==0){
				ans = krug[used[k]-1+used[sp[k][i]]];
				kans = used[k]-1+used[sp[k][i]];
			}
		}
	}

	ans+=stree[kans-1]*(stree[n-kans+1]-1)+stree[n-kans]*stree[kans-1];

	fout<<ans%p<<'\n';
	return 0;
}