#include <iostream>
using namespace std;
int p;
int data[110000];
int prev[110000];
int next[110000];
int head[51000];
int a[110000];
int b[110000];
bool circle[51000];
bool z[51000];
int n;

int rec (int x){
	if (x==n) return 1;
	if (!z[x]) return rec(x+1); 
	z[x]=false;
	int y=rec (x+1);
	for (int t=head[x]; t>-1; t=prev[t])
		if (data[t]>x && z[data[t]]){
			z[data[t]]=false;
			y+=rec (x+1);
			y%=p;
			z[data[t]]=true;
		}
	z[x]=true;
	return y%p;
}

int f(){
	for (int t=0; t<n; t++) z[t]=true;
	return rec(0)%p;
}

bool dfs (int x, int pr){
	if (!z[x])
	{
		circle[x]=true;
		return true;
	}
	z[x]=false;
	int y=head[x];
	while (y>=0){
		if (data[y]!=pr && dfs (data[y],x)){
			circle[x]=true;
			return true;
		}
		y=prev[y];
	}
	return false;
}

int main(){
	freopen ("MUSEUM.DAT","r",stdin);
	freopen ("MUSEUM.SOL","w",stdout);
	scanf ("%d%d",&n,&p);
	for (int t=0; t<n; t++) head[t]=-1, circle[t]=false;
	int kl=0,k;
	for (int t=0; t<n; t++){
		int x,y;
		scanf ("%d%d", &x, &y);
		x--, y--;
		data[kl]=y;
		prev[kl]=head[x];
		next[kl]=-1;
		if (head[x]!=-1) next[head[x]]=kl;
		head[x]=kl;
		kl++;
		
		k=x;
		x=y;
		y=k;
		data[kl]=y;
		prev[kl]=head[x];
		next[kl]=-1;
		if (head[x]!=-1) next[head[x]]=kl;
		head[x]=kl;
		kl++;
	}
	k=f();
	for (int t=0; t<n; t++) z[t]=true;
	dfs(0,-2);
	for (int t=0; t<n; t++){
		if (circle[t]) head[t]=-1;
		while (head[t]>=0 && circle[head[t]]) head[t]=prev[head[t]], next[head[t]]=-1;
	}
	for (int t=0; t<kl; t++)
		if (circle[data[t]]) next[prev[t]]=next[t];
	k+=2*f();
	printf ("%d\n",k);
	return 0;
}
