#include <cstdio>
#include <cstdlib>

int main()
{
        const char *InFile = "MUTATION.DAT";
        const char *OutFile = "MUTATION.SOL";
        const int SMax = 80000;

	int s1, s2, n, steps;
	int g1[SMax];
	int g2[SMax];
	int i;
	int changes = 0;
	
	freopen(InFile, "rt", stdin);
	scanf("%d%d%d%d", &s1, &s2, &n, &steps);
	scanf("\n");
	for (i=0; i<s1; i++) {
		char ch;
		scanf("%c", &ch);
		g1[i] = ch=='1' ? 1 : 0;
	}
	scanf("\n");
	for (i=0; i<s2; i++) {
		char ch;
		scanf("%c", &ch);
		g2[i] = ch=='1' ? 1 : 0;
	}
	int p1 = 0;
	int p2 = 0;
	int parsed = 0;
	do {
		int c1 = g1[p1];
		int c2 = g2[p2];
		if (c1!=c2) {
			changes++;
		}
		p1++;
		p2++;
		if (p1>=s1) p1 = 0;
		if (p2>=s2) p2 = 0;
		parsed++;
	} while (p1!=0 || p2!=0);
	changes *= n/parsed;
	int was = -1;
	for (i=0; i<steps; i++) {
		int change;
		scanf("%d", &change);
		changes -= change;
		if (!changes) {
			was = i+1;
			break;
		}
		changes = abs(changes);
	}
	fclose(stdin);
	
	freopen(OutFile, "wt", stdout);
	printf("%d\n", was);
	fclose(stdout);
	
	return 0;
}
