#include <iostream>
#include <algorithm>
using namespace std;

int nod(int a, int b)
{
	if (a < b)
	{
		swap(a,b);
	}
	while (b > 0)
	{
		int r = a % b;
		a = b;
		b = r;
	}
	return a;
}

int nok(int a, int b)
{
	int c = nod(a,b);
	return a*b/c;
}

int main()
{
	freopen("MUTATION.DAT","r",stdin);
	freopen("MUTATION.SOL","w",stdout);
	int A, B, N, M;
	cin >> A >> B >> N >> M;
	char ch;
	bool* P1 = new bool [A];
	for (int i=0; i<A; i++)
	{
		cin >> ch;
		P1[i] = ch - '0';
	}
	bool* P2 = new bool [B];	
	for (int i=0; i<B; i++)
	{
		cin >> ch;
		P2[i] = ch - '0';
	}
	int n = 0;
	int AB_nok = nok(A,B);
	for (int i=0; i<AB_nok; i++)
	{
		if ( P1[i%A] ^ P2[i%B] == 1 )
		{
			n++;
		}
	}
	n *= N / AB_nok;
	int k;
	if (n == 0)
	{
		cout << 0 << endl;
		return 0;
	}
	int* ar = new int [M+1] ();
	ar[0] = n;
	for (int i=0; i<M; i++)
	{
		cin >> k;
		int j = 0;
		while (k>ar[j])
		{
			j++;
		}
		int l;
		for (l=i; k>ar[l] && l>=0; l--)
		{
			ar[l+1] = ar[l];
		}
		ar[l+1] = k;
		__int64 s1 = 0, s2 = 0;
		for (int p=0; p<=i+1; p++)
		{
			if (s1 < s2)
			{
				s1 += ar[p];
			}
			else
			{
				s2 += ar[p];
			}
		}
		if (s1 == s2)
		{
			cout << (i+1) << endl;
			return 0;
		}
	}
	return 0;
}